%bcond_without golang
# Building check cannot run correctly without vm, so it's suggested to
# run after installation using 'make installcheck'.
# see https://listman.redhat.com/archives/libguestfs/2015-September/msg00078.html.
%bcond_with test
%bcond_without ocaml

%{?perl_default_filter}

%undefine _strict_symbol_defs_build

%global api_ver %%(echo %{version} | cut -d. -f1-2)

Summary:       Access and modify virtual machine disk images
Name:          libguestfs
Version:       1.53.2
Release:       2%{?dist}
License:       LGPLv2+

URL:           http://libguestfs.org/
Source0:       http://libguestfs.org/download/%{api_ver}-development/%{name}-%{version}.tar.gz
Source1:       guestfish.sh
Source2:       yum.conf.in

BuildRequires: autoconf, automake, libtool, gettext-devel gcc gcc-c++ make
BuildRequires: rpcgen libtirpc-devel supermin-devel >= 5.1.18 ocaml-augeas-devel
BuildRequires: perl(Pod::Simple) perl(Pod::Man) /usr/bin/pod2text
BuildRequires: po4a augeas-devel >= 1.7.0 readline-devel xorriso libxml2-devel
BuildRequires: createrepo_c glibc-static libselinux-utils libselinux-devel
BuildRequires: fuse fuse-devel pcre2-devel file-devel libvirt-devel /usr/bin/qemu-img
BuildRequires: gperf flex bison rpm-devel cpio libconfig-devel xz-devel
BuildRequires: systemd-units netpbm-progs netpbm-progs icoutils libvirt-daemon-kvm >= 7.1.0
BuildRequires: libacl-devel libcap-devel jansson-devel systemd-devel bash-completion
BuildRequires: /usr/bin/wget xz hivex-devel >= 1.3.10
BuildRequires: lua lua-devel perl-devel perl-generators perl-macros gjs vala
BuildRequires: perl(Test::More) perl(Test::Pod) >= 1.00 perl(Test::Pod::Coverage) >= 1.00
BuildRequires: perl(Module::Build) perl(ExtUtils::CBuilder) perl(Locale::TextDomain)
BuildRequires: python3-devel python3-libvirt ruby-devel rubygem-rake rubygem(json)
BuildRequires: rubygem(rdoc) rubygem(test-unit) ruby-irb php-devel gobject-introspection-devel
BuildRequires: acl attr augeas-libs bash binutils bzip2 clevis-luks
BuildRequires: coreutils cpio cryptsetup dhclient diffutils dosfstools
BuildRequires: e2fsprogs file findutils gawk gdisk grep gzip hivex-libs iproute iputils
BuildRequires: kmod less libcap libselinux libxml2 lsof lsscsi lvm2 lzop mdadm
BuildRequires: openssh-clients parted pciutils pcre2 policycoreutils procps psmisc qemu-img rpm-libs rsync
BuildRequires: systemd tar udev util-linux vim-minimal xfsprogs yajl zstd
BuildRequires: scrub sed squashfs-tools strace
%if %{with golang}
BuildRequires: golang
%endif 
%if %{with ocaml}
BuildRequires: ocaml-hivex-devel ocaml ocaml-ocamldoc ocaml-findlib-devel
%endif
%ifarch x86_64
BuildRequires: syslinux syslinux-extlinux
%endif

Suggests:      qemu-block-rbd
Recommends:    libvirt-daemon-config-network

%ifarch aarch64
Requires:      edk2-aarch64
%endif

Requires: /usr/bin/hexedit /usr/bin/less /usr/bin/man /usr/bin/vi
Requires: libvirt-daemon-driver-secret libvirt-daemon-driver-storage-core selinux-policy >= 3.11.1-63
Requires: tar xz qemu-kvm-core libvirt-daemon-driver-qemu >= 7.1.0
Requires: systemd-libs yajl fuse /usr/bin/qemu-img coreutils grep
Requires: pcre2 rpm-libs >= 4.16.1.3
Requires: libacl libcap libselinux hivex-libs >= 1.3.10
Requires: (%{name}-appliance = %{version}-%{release} or %{name}-noappliance) augeas-libs >= 1.7.0


%description
Libguestfs is a library for accessing and modifying virtual machine
disk images.  http://libguestfs.org

Libguestfs uses Linux kernel and qemu code, and can access any type of
guest filesystem that Linux and qemu can, including but not limited
to: ext2/3/4, btrfs, FAT and NTFS, LVM, many different disk partition
schemes, qcow, qcow2, vmdk.

For enhanced features, install:

 libguestfs-inspect-icons  adds support for inspecting guest icons
        libguestfs-rescue  enhances virt-rescue shell with more tools
         libguestfs-rsync  rsync to/from guest filesystems
           libguestfs-xfs  adds XFS support

For developers:

         libguestfs-devel  C/C++ header files and library

Language bindings:

 libguestfs-gobject-devel  GObject bindings and GObject Introspection
%if %{with golang}
           golang-guestfs  Go language bindings
%endif
              lua-guestfs  Lua bindings
%if %{with ocaml}
   ocaml-libguestfs-devel  OCaml bindings
%endif
         perl-Sys-Guestfs  Perl bindings
           php-libguestfs  PHP bindings
       python3-libguestfs  Python 3 bindings
          ruby-libguestfs  Ruby bindings
          libguestfs-vala  Vala language bindings


%package appliance
Summary:       Appliance for %{name}
Requires:      supermin >= 5.1.18


%description appliance
%{name}-appliance provides the appliance used by libguestfs.


%package devel
Summary:       Development tools and libraries for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      pkgconfig


%description devel
%{name}-devel contains development tools and libraries
for %{name}.

%package rescue 
Summary:       virt-rescue shell
License:       LGPLv2+
Requires:      %{name} = %{version}-%{release}

%description rescue
This adds the virt-rescue shell which is a "rescue disk" for virtual
machines, and additional tools to use inside the shell such as ssh,
network utilities, editors and debugging utilities.


%package inspect-icons
Summary:       Additional dependencies for inspecting guest icons
License:       LGPLv2+
BuildArch:     noarch
Requires:      %{name} = %{version}-%{release}
Requires:      netpbm-progs
Requires:      icoutils


%description inspect-icons
%{name}-inspect-icons is a metapackage that pulls in additional
dependencies required by libguestfs to pull icons out of non-Linux
guests.  Install this package if you want libguestfs to be able to
inspect non-Linux guests and display icons from them.

%package bash-completion
Summary:       Bash tab-completion scripts for %{name} tools
BuildArch:     noarch
Requires:      bash-completion >= 2.0


%description bash-completion
Install this package if you want intelligent bash tab-completion
for guestfish, guestmount and various virt-* tools.

%if %{with ocaml}
%package -n ocaml-%{name}
Summary:       OCaml bindings for %{name}
Requires:      %{name} = %{version}-%{release}


%description -n ocaml-%{name}
ocaml-%{name} contains OCaml bindings for %{name}.

This is for toplevel and scripting access only.  To compile OCaml
programs which use %{name} you will also need ocaml-%{name}-devel.


%package -n ocaml-%{name}-devel
Summary:       OCaml bindings for %{name}
Requires:      ocaml-%{name} = %{version}-%{release}


%description -n ocaml-%{name}-devel
ocaml-%{name}-devel contains development libraries
required to use the OCaml bindings for %{name}.
%endif

%package -n perl-Sys-Guestfs
Summary:       Perl bindings for %{name} (Sys::Guestfs)
Requires:      %{name} = %{version}-%{release}
Requires:      perl-libs


%description -n perl-Sys-Guestfs
perl-Sys-Guestfs contains Perl bindings for %{name} (Sys::Guestfs).


%package -n python3-%{name}
Summary:       Python 3 bindings for %{name}
Requires:      %{name} = %{version}-%{release}

%description -n python3-%{name}
python3-%{name} contains Python 3 bindings for %{name}.


%package -n ruby-%{name}
Summary:       Ruby bindings for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      ruby(release)
Requires:      ruby
Provides:      ruby(guestfs) = %{version}

%description -n ruby-%{name}
ruby-%{name} contains Ruby bindings for %{name}.


%package -n php-%{name}
Summary:       PHP bindings for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:	   php(zend-abi) = %{php_zend_api}
Requires:	   php(api) = %{php_core_api}

%description -n php-%{name}
php-%{name} contains PHP bindings for %{name}.


%package -n lua-guestfs
Summary:       Lua bindings for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      lua

%description -n lua-guestfs
lua-guestfs contains Lua bindings for %{name}.


%package gobject
Summary:       GObject bindings for %{name}
Requires:      %{name} = %{version}-%{release}

%description gobject
%{name}-gobject contains GObject bindings for %{name}.

To develop software against these bindings, you need to install
%{name}-gobject-devel.


%package gobject-devel
Summary:       GObject bindings for %{name}
Requires:      %{name}-gobject = %{version}-%{release}

%description gobject-devel
%{name}-gobject contains GObject bindings for %{name}.

This package is needed if you want to write software using the
GObject bindings.  It also contains GObject Introspection information.


%package vala
Summary:       Vala for %{name}
Requires:      %{name}-devel = %{version}-%{release}
Requires:      vala

%description vala
%{name}-vala contains GObject bindings for %{name}.


%if %{with golang}
%package -n golang-guestfs
Summary:       Golang bindings for %{name}
BuildArch:     noarch
Requires:      %{name} = %{version}-%{release}
Requires:      golang
Provides:      golang(libguestfs.org) = %{version}-%{release}

%description -n golang-guestfs
golang-%{name} contains Go language bindings for %{name}.
%endif

%package xfs
Summary:       XFS support for %{name}
License:       LGPLv2+
Requires:      %{name} = %{version}-%{release}

%description xfs
This adds XFS support to %{name}.  Install it if you want to process
disk images containing XFS.

%package man-pages-ja
Summary:       Japanese (ja) man pages for %{name}
BuildArch:     noarch
Requires:      %{name} = %{version}-%{release}

%description man-pages-ja
%{name}-man-pages-ja contains Japanese (ja) man pages
for %{name}.


%package man-pages-uk
Summary:       Ukrainian (uk) man pages for %{name}
BuildArch:     noarch
Requires:      %{name} = %{version}-%{release}

%description man-pages-uk
%{name}-man-pages-uk contains Ukrainian (uk) man pages
for %{name}.


%prep
%autosetup -p1


if [ "$(stat -f -L -c %T .)" != "nfs" ] && \
   [ "$(getenforce | tr '[A-Z]' '[a-z]')" != "disabled" ]; then
    chcon --reference=/tmp tmp
fi


%build
autoreconf -i

mkdir cachedir repo
find /var/cache/{dnf,yum} -type f -name '*.rpm' -print0 | \
  xargs -0 -n 1 cp -t repo
createrepo_c repo
sed -e "s|@PWD@|$(pwd)|" %{SOURCE2} > yum.conf
extra=--with-supermin-packager-config=$(pwd)/yum.conf

%{configure} \
  PYTHON=%{__python3} \
  --with-default-backend=libvirt \
  --enable-appliance-format-auto \
  --with-extra="libvirt" \
  --with-qemu="qemu-kvm qemu-system-%{_build_arch} qemu" \
%if %{without golang}
  --disable-golang \
%endif
  --without-java \
  --disable-erlang \
%if %{without ocaml}
  --disable-ocaml \
%endif
  $extra

%make_build INSTALLDIRS=vendor

%install
%make_install INSTALLDIRS=vendor NO_PACKLIST=1

rm $( find %{buildroot} -name '*.a' | grep -v /ocaml/ )

find %{buildroot} -name '*.la' -delete
find %{buildroot} -name perllocal.pod -delete
find %{buildroot} -name '*.bs' -delete
find %{buildroot} -name 'bindtests.pl' -delete

%if %{with golang}
mkdir -p %{buildroot}%{_datadir}/gocode/src
cp -a golang/src/libguestfs.org %{buildroot}%{_datadir}/gocode/src
%endif

mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/profile.d

rm ocaml/html/.gitignore


%find_lang %{name}


%check
%if %{with test}
if grep CONFIG_DEBUG_MUTEXES=y /lib/modules/*/config ; then
    exit 0
fi

export LIBGUESTFS_DEBUG=1
export LIBGUESTFS_TRACE=1
export LIBVIRT_DEBUG=1

if ! make quickcheck QUICKCHECK_TEST_TOOL_ARGS="-t 1200"; then
    cat $HOME/.cache/libvirt/qemu/log/*
    exit 1
fi
%endif

%files -f %{name}.lang
%license COPYING COPYING.LIB
%doc README
%{_bindir}/guestfish
%{_bindir}/guestmount
%{_bindir}/guestunmount
%{_bindir}/libguestfs-test-tool
%{_bindir}/virt-copy-in
%{_bindir}/virt-copy-out
%{_bindir}/virt-tar-in
%{_bindir}/virt-tar-out
%{_sbindir}/libguestfs-make-fixed-appliance
%{_libdir}/libguestfs.so.*
%{_mandir}/man1/guestfish.1*
%{_mandir}/man1/guestfs-faq.1*
%{_mandir}/man1/guestfs-performance.1*
%{_mandir}/man1/guestfs-recipes.1*
%{_mandir}/man1/guestfs-release-notes-1*.1*
%{_mandir}/man1/guestfs-release-notes.1*
%{_mandir}/man1/guestfs-security.1*
%{_mandir}/man1/guestmount.1*
%{_mandir}/man1/guestunmount.1*
%{_mandir}/man1/libguestfs-make-fixed-appliance.1*
%{_mandir}/man1/libguestfs-test-tool.1*
%{_mandir}/man1/virt-copy-in.1*
%{_mandir}/man1/virt-copy-out.1*
%{_mandir}/man1/virt-tar-in.1*
%{_mandir}/man1/virt-tar-out.1*
%{_mandir}/man5/libguestfs-tools.conf.5*
%config %{_sysconfdir}/profile.d/guestfish.sh
%config(noreplace) %{_sysconfdir}/libguestfs-tools.conf


%files appliance
%{_libdir}/guestfs/


%files devel
%doc AUTHORS HACKING TODO README
%doc examples/*.c
%{_libdir}/libguestfs.so
%{_libdir}/pkgconfig/libguestfs.pc
%{_includedir}/guestfs.h
%{_mandir}/man1/guestfs-building.1*
%{_mandir}/man1/guestfs-hacking.1*
%{_mandir}/man1/guestfs-internals.1*
%{_mandir}/man1/guestfs-testing.1*
%{_mandir}/man3/guestfs.3*
%{_mandir}/man3/guestfs-examples.3*
%{_mandir}/man3/libguestfs.3*


%files rescue
%{_bindir}/virt-rescue
%{_mandir}/man1/virt-rescue.1*

%files inspect-icons
# no files


%files bash-completion
%dir %{_datadir}/bash-completion/completions
%{_datadir}/bash-completion/completions/guestfish
%{_datadir}/bash-completion/completions/guestmount
%{_datadir}/bash-completion/completions/guestunmount
%{_datadir}/bash-completion/completions/libguestfs-test-tool
%{_datadir}/bash-completion/completions/virt-copy-in
%{_datadir}/bash-completion/completions/virt-copy-out
%{_datadir}/bash-completion/completions/virt-rescue
%{_datadir}/bash-completion/completions/virt-tar-in
%{_datadir}/bash-completion/completions/virt-tar-out

%if %{with ocaml}
%files -n ocaml-%{name}
%{_libdir}/ocaml/guestfs
%exclude %{_libdir}/ocaml/guestfs/*.a
%exclude %{_libdir}/ocaml/guestfs/*.cmxa
%exclude %{_libdir}/ocaml/guestfs/*.cmx
%exclude %{_libdir}/ocaml/guestfs/*.mli
%{_libdir}/ocaml/stublibs/dllmlguestfs.so
%{_libdir}/ocaml/stublibs/dllmlguestfs.so.owner


%files -n ocaml-%{name}-devel
%doc ocaml/examples/*.ml ocaml/html
%{_libdir}/ocaml/guestfs/*.a
%{_libdir}/ocaml/guestfs/*.cmxa
%{_libdir}/ocaml/guestfs/*.cmx
%{_libdir}/ocaml/guestfs/*.mli
%{_mandir}/man3/guestfs-ocaml.3*
%endif

%files -n perl-Sys-Guestfs
%doc perl/examples/*.pl
%{perl_vendorarch}/*
%{_mandir}/man3/Sys::Guestfs.3pm*
%{_mandir}/man3/guestfs-perl.3*


%files -n python3-%{name}
%doc python/examples/*.py
%{python3_sitearch}/libguestfsmod*.so
%{python3_sitearch}/guestfs.py
%{python3_sitearch}/__pycache__/guestfs*.py*
%{_mandir}/man3/guestfs-python.3*


%files -n ruby-%{name}
%doc ruby/examples/*.rb
%doc ruby/doc/site/*
%{ruby_vendorlibdir}/guestfs.rb
%{ruby_vendorarchdir}/_guestfs.so
%{_mandir}/man3/guestfs-ruby.3*


%files -n php-%{name}
%doc php/README-PHP
%dir %{_sysconfdir}/php.d
%{_sysconfdir}/php.d/guestfs_php.ini
%{_libdir}/php/modules/guestfs_php.so


%files -n lua-guestfs
%doc lua/examples/*.lua
%doc lua/examples/LICENSE
%{_libdir}/lua/*/guestfs.so
%{_mandir}/man3/guestfs-lua.3*


%files gobject
%{_libdir}/libguestfs-gobject-1.0.so.0*
%{_libdir}/girepository-1.0/Guestfs-1.0.typelib


%files gobject-devel
%{_libdir}/libguestfs-gobject-1.0.so
%{_includedir}/guestfs-gobject.h
%dir %{_includedir}/guestfs-gobject
%{_includedir}/guestfs-gobject/*.h
%{_datadir}/gir-1.0/Guestfs-1.0.gir
%{_libdir}/pkgconfig/libguestfs-gobject-1.0.pc
%{_mandir}/man3/guestfs-gobject.3*


%files vala
%{_datadir}/vala/vapi/libguestfs-gobject-1.0.deps
%{_datadir}/vala/vapi/libguestfs-gobject-1.0.vapi

%if %{with golang}
%files -n golang-guestfs
%license golang/examples/LICENSE
%{_datadir}/gocode/src/libguestfs.org
%{_mandir}/man3/guestfs-golang.3*
%endif

%files xfs
# empty

%files man-pages-ja
%lang(ja) %{_mandir}/ja/man1/*.1*
%lang(ja) %{_mandir}/ja/man3/*.3*
%lang(ja) %{_mandir}/ja/man5/*.5*


%files man-pages-uk
%lang(uk) %{_mandir}/uk/man1/*.1*
%lang(uk) %{_mandir}/uk/man3/*.3*
%lang(uk) %{_mandir}/uk/man5/*.5*

%changelog
* Tue Jul 02 2024 Rebuild Robot <rebot@opencloudos.org> - 1.53.2-2
- [Type] other
- [DESC] Rebuilt for hivex

* Mon Jun 24 2024 cunshunxia <cunshunxia@tencent.com> - 1.53.2-1
- upgrade to 1.53.2 for ocaml 5.2.0.

* Tue Mar 19 2024 Rebuild Robot <rebot@opencloudos.org> - 1.51.6-8
- Rebuilt for jansson

* Fri Oct 20 2023 jackeyji <jackeyji@tencent.com> - 1.51.6-7
- Rebuilt for qemu CVE fix

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.51.6-6
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.51.6-5
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Sep 04 2023 Miaojun Dong <zoedong@tencent.com> - 1.51.6-4
- Rebuild for php-8.2.9

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 1.51.6-3
- Rebuilt for netpbm 11.02.00

* Thu Aug 17 2023 Miaojun Dong <zoedong@tencent.com> - 1.51.6-2
- Rebuild for parted-3.6
- Add new subpackage vala as it is auto added to build arguments

* Thu Aug 10 2023 Shuo Wang <abushwang@tencent.com> - 1.51.6-1
- update to 1.51.6

* Wed Jul 19 2023 Miaojun Dong <zoedong@tencent.com> - 1.50.1-5
- Rebuild for libvirt-9.4.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.50.1-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.50.1-3
- Rebuilt for OpenCloudOS Stream 23

* Fri Mar 31 2023 cunshunxia <cunshunxia@tencent.com> - 1.50.1-2
- provide xfs in subpkg.

* Thu Mar 30 2023 cunshunxia <cunshunxia@tencent.com> - 1.50.1-1
- upgrade to 1.50.1 for virt-v2v

* Fri Mar 24 2023 cunshunxia <cunshunxia@tencent.com> - 1.49.6-1
- initial build
